// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef MULTIPLIER_HH
#define MULTIPLIER_HH

#include <cstddef>
#include <stdint.h>

class multiplier
{

public:

    uint16_t op2_old;
    uint16_t op1_old;
    bool din_rdy_old;
    bool clk_old;
    struct multiplier_iostruct{
        bool * clk;
        bool * din_rdy;
        uint16_t * op1;
        uint16_t * op2;
        uint32_t * result;
        bool * dout_rdy;

        multiplier_iostruct():
            clk(nullptr),
            din_rdy(nullptr),
            op1(nullptr),
            op2(nullptr),
            result(nullptr),
            dout_rdy(nullptr)
        {}

        multiplier_iostruct( bool * clk_2, bool * din_rdy_0, uint16_t * op1_0, uint16_t
             * op2_0, uint32_t * result_0, bool * dout_rdy_0 ):
            clk(clk_2),
            din_rdy(din_rdy_0),
            op1(op1_0),
            op2(op2_0),
            result(result_0),
            dout_rdy(dout_rdy_0)
        {}

        ~multiplier_iostruct()
        {}

        bool operator == (const multiplier_iostruct & other) const
        {
            if (clk != other.clk) return false;
            if (din_rdy != other.din_rdy) return false;
            if (op1 != other.op1) return false;
            if (op2 != other.op2) return false;
            if (result != other.result) return false;
            if (dout_rdy != other.dout_rdy) return false;
            return true;
        }
    };
    multiplier_iostruct hif_a2t_data;
    bool clkSuphif_1;
    multiplier();


    ~multiplier();


    bool clkSuphif_1_new;
    bool process_in_queue;
    bool flag_vhdl_process_UpdclkSuphif_1_executed;
    bool flag_clk;

    void vhdl_process_UpdclkSuphif_1();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    multiplier( const multiplier & );
    const multiplier& operator= ( const multiplier & );


};


#endif

